DL_FixedBasePrecomputationImpl< T > Class Template Reference

DL_FixedBasePrecomputation adapter class. More...

`#include <eprecomp.h>`

Inheritance diagram for DL_FixedBasePrecomputationImpl< T >:

## Public Types

typedef T | Element
Public Types inherited from DL_FixedBasePrecomputation< T >
typedef T | Element

## Public Member Functions

bool | IsInitialized () const
| Determines whether this object is initialized.
void | SetBase (const DL_GroupPrecomputation< Element > &group, const Element &base)
| Set the base element.
const Element & | GetBase (const DL_GroupPrecomputation< Element > &group) const
| Get the base element.
void | Precompute (const DL_GroupPrecomputation< Element > &group, unsigned int maxExpBits, unsigned int storage)
| Perform precomputation.
void | Load (const DL_GroupPrecomputation< Element > &group, BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation.
void | Save (const DL_GroupPrecomputation< Element > &group, BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use.
Element | Exponentiate (const DL_GroupPrecomputation< Element > &group, const Integer &exponent) const
| Exponentiates an element.
Element | CascadeExponentiate (const DL_GroupPrecomputation< Element > &pc1, const Integer &exponent1, const DL_FixedBasePrecomputation< Element > &pc2, const Integer &exponent2) const
| Exponentiates an element.

## Detailed Description

template<class T>
class DL_FixedBasePrecomputationImpl< T >

DL_FixedBasePrecomputation adapter class.

Template Parameters

  T | Field element

Definition at line 126 of file eprecomp.h.

## Member Typedef Documentation

## Element

template<class T >

typedef T DL_FixedBasePrecomputationImpl< T >::Element

Definition at line 129 of file eprecomp.h.

## Constructor & Destructor Documentation

## ~DL_FixedBasePrecomputationImpl()

template<class T >

virtual DL_FixedBasePrecomputationImpl< T >::~DL_FixedBasePrecomputationImpl | ( |  | ) |

inline virtual

Definition at line 131 of file eprecomp.h.

## DL_FixedBasePrecomputationImpl()

template<class T >

DL_FixedBasePrecomputationImpl< T >::DL_FixedBasePrecomputationImpl | ( |  | ) |

inline

Definition at line 133 of file eprecomp.h.

## Member Function Documentation

## IsInitialized()

template<class T >

bool DL_FixedBasePrecomputationImpl< T >::IsInitialized | ( |  | ) | const

inline virtual

Determines whether this object is initialized.

Returns
  true if this object is initialized, false otherwise

Implements DL_FixedBasePrecomputation< T >.

Definition at line 136 of file eprecomp.h.

## SetBase()

template<class T >

void DL_FixedBasePrecomputationImpl< T >::SetBase | ( | const DL_GroupPrecomputation< Element > & | group,
|  | const Element & | base
| ) |  |

virtual

Set the base element.

Parameters

  group | the group
  base | element in the group

Implements DL_FixedBasePrecomputation< T >.

## GetBase()

template<class T >

const Element & DL_FixedBasePrecomputationImpl< T >::GetBase | ( | const DL_GroupPrecomputation< Element > & | group | ) | const

inline virtual

Get the base element.

Parameters

  group | the group

Returns
  base element in the group

Implements DL_FixedBasePrecomputation< T >.

Definition at line 139 of file eprecomp.h.

## Precompute()

template<class T >

void DL_FixedBasePrecomputationImpl< T >::Precompute | ( | const DL_GroupPrecomputation< Element > & | group,
|  | unsigned int | maxExpBits,
|  | unsigned int | storage
| ) |  |

virtual

Perform precomputation.

Parameters

  group | the group
  maxExpBits | used to calculate the exponent base
  storage | the suggested number of objects for the precompute table

The exact semantics of Precompute() varies, but it typically means calculate a table of n objects that can be used later to speed up computation.

If a derived class does not override Precompute(), then the base class throws NotImplemented.

See also
  SupportsPrecomputation(), LoadPrecomputation(), SavePrecomputation()

Implements DL_FixedBasePrecomputation< T >.

## Load()

template<class T >

void DL_FixedBasePrecomputationImpl< T >::Load | ( | const DL_GroupPrecomputation< Element > & | group,
|  | BufferedTransformation & | storedPrecomputation
| ) |  |

virtual

Retrieve previously saved precomputation.

Parameters

  group | the group
  storedPrecomputation | BufferedTransformation with the saved precomputation

Exceptions

  NotImplemented |

See also
  SupportsPrecomputation(), Precompute()

Implements DL_FixedBasePrecomputation< T >.

## Save()

template<class T >

void DL_FixedBasePrecomputationImpl< T >::Save | ( | const DL_GroupPrecomputation< Element > & | group,
|  | BufferedTransformation & | storedPrecomputation
| ) |  | const

virtual

Save precomputation for later use.

Parameters

  group | the group
  storedPrecomputation | BufferedTransformation to write the precomputation

Exceptions

  NotImplemented |

See also
  SupportsPrecomputation(), Precompute()

Implements DL_FixedBasePrecomputation< T >.

## Exponentiate()

template<class T >

Element DL_FixedBasePrecomputationImpl< T >::Exponentiate | ( | const DL_GroupPrecomputation< Element > & | group,
|  | const Integer & | exponent
| ) |  | const

virtual

Exponentiates an element.

Parameters

  group | the group
  exponent | the exponent

Returns
  the result of the exponentiation

Implements DL_FixedBasePrecomputation< T >.

## CascadeExponentiate()

template<class T >

Element DL_FixedBasePrecomputationImpl< T >::CascadeExponentiate | ( | const DL_GroupPrecomputation< Element > & | pc1,
|  | const Integer & | exponent1,
|  | const DL_FixedBasePrecomputation< Element > & | pc2,
|  | const Integer & | exponent2
| ) |  | const

virtual

Exponentiates an element.

Parameters

  pc1 | the first the group precomputation
  exponent1 | the first exponent
  pc2 | the second the group precomputation
  exponent2 | the first exponent2

Returns
  the public element raised to the exponent

CascadeExponentiateBaseAndPublicElement raises the public element to the base element and precomputation.

Implements DL_FixedBasePrecomputation< T >.

The documentation for this class was generated from the following file:

- eprecomp.h